# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from fireblocks_client.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    VAULT_ACCOUNTS = "/vault/accounts"
    VAULT_ACCOUNTS_PAGED = "/vault/accounts_paged"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID = "/vault/accounts/{vaultAccountId}"
    VAULT_ASSET_WALLETS = "/vault/asset_wallets"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_HIDE = "/vault/accounts/{vaultAccountId}/hide"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_UNHIDE = "/vault/accounts/{vaultAccountId}/unhide"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_ACTIVATE = "/vault/accounts/{vaultAccountId}/{assetId}/activate"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_SET_CUSTOMER_REF_ID = "/vault/accounts/{vaultAccountId}/set_customer_ref_id"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_SET_AUTO_FUEL = "/vault/accounts/{vaultAccountId}/set_auto_fuel"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID = "/vault/accounts/{vaultAccountId}/{assetId}"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_BALANCE = "/vault/accounts/{vaultAccountId}/{assetId}/balance"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_ADDRESSES = "/vault/accounts/{vaultAccountId}/{assetId}/addresses"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_MAX_SPENDABLE_AMOUNT = "/vault/accounts/{vaultAccountId}/{assetId}/max_spendable_amount"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_ADDRESSES_ADDRESS_ID = "/vault/accounts/{vaultAccountId}/{assetId}/addresses/{addressId}"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_ADDRESSES_ADDRESS_ID_SET_CUSTOMER_REF_ID = "/vault/accounts/{vaultAccountId}/{assetId}/addresses/{addressId}/set_customer_ref_id"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_ADDRESSES_ADDRESS_ID_CREATE_LEGACY = "/vault/accounts/{vaultAccountId}/{assetId}/addresses/{addressId}/create_legacy"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_UNSPENT_INPUTS = "/vault/accounts/{vaultAccountId}/{assetId}/unspent_inputs"
    VAULT_PUBLIC_KEY_INFO_ = "/vault/public_key_info/"
    VAULT_ACCOUNTS_VAULT_ACCOUNT_ID_ASSET_ID_CHANGE_ADDRESS_INDEX_PUBLIC_KEY_INFO = "/vault/accounts/{vaultAccountId}/{assetId}/{change}/{addressIndex}/public_key_info"
    VAULT_ASSETS = "/vault/assets"
    VAULT_ASSETS_ASSET_ID = "/vault/assets/{assetId}"
    EXCHANGE_ACCOUNTS = "/exchange_accounts"
    EXCHANGE_ACCOUNTS_EXCHANGE_ACCOUNT_ID = "/exchange_accounts/{exchangeAccountId}"
    EXCHANGE_ACCOUNTS_EXCHANGE_ACCOUNT_ID_INTERNAL_TRANSFER = "/exchange_accounts/{exchangeAccountId}/internal_transfer"
    EXCHANGE_ACCOUNTS_EXCHANGE_ACCOUNT_ID_CONVERT = "/exchange_accounts/{exchangeAccountId}/convert"
    EXCHANGE_ACCOUNTS_EXCHANGE_ACCOUNT_ID_ASSET_ID = "/exchange_accounts/{exchangeAccountId}/{assetId}"
    FIAT_ACCOUNTS = "/fiat_accounts"
    FIAT_ACCOUNTS_ACCOUNT_ID = "/fiat_accounts/{accountId}"
    FIAT_ACCOUNTS_ACCOUNT_ID_REDEEM_TO_LINKED_DDA = "/fiat_accounts/{accountId}/redeem_to_linked_dda"
    FIAT_ACCOUNTS_ACCOUNT_ID_DEPOSIT_FROM_LINKED_DDA = "/fiat_accounts/{accountId}/deposit_from_linked_dda"
    NETWORK_CONNECTIONS = "/network_connections"
    NETWORK_CONNECTIONS_CONNECTION_ID_SET_ROUTING_POLICY = "/network_connections/{connectionId}/set_routing_policy"
    NETWORK_CONNECTIONS_CONNECTION_ID_IS_THIRD_PARTY_ROUTING_ASSET_TYPE = "/network_connections/{connectionId}/is_third_party_routing/{assetType}"
    NETWORK_CONNECTIONS_CONNECTION_ID = "/network_connections/{connectionId}"
    NETWORK_IDS = "/network_ids"
    NETWORK_IDS_NETWORK_ID = "/network_ids/{networkId}"
    NETWORK_IDS_NETWORK_ID_SET_ROUTING_POLICY = "/network_ids/{networkId}/set_routing_policy"
    NETWORK_IDS_NETWORK_ID_SET_DISCOVERABILITY = "/network_ids/{networkId}/set_discoverability"
    NETWORK_IDS_NETWORK_ID_SET_NAME = "/network_ids/{networkId}/set_name"
    INTERNAL_WALLETS = "/internal_wallets"
    INTERNAL_WALLETS_WALLET_ID = "/internal_wallets/{walletId}"
    INTERNAL_WALLETS_WALLET_ID_SET_CUSTOMER_REF_ID = "/internal_wallets/{walletId}/set_customer_ref_id"
    INTERNAL_WALLETS_WALLET_ID_ASSET_ID = "/internal_wallets/{walletId}/{assetId}"
    EXTERNAL_WALLETS = "/external_wallets"
    EXTERNAL_WALLETS_WALLET_ID = "/external_wallets/{walletId}"
    EXTERNAL_WALLETS_WALLET_ID_SET_CUSTOMER_REF_ID = "/external_wallets/{walletId}/set_customer_ref_id"
    EXTERNAL_WALLETS_WALLET_ID_ASSET_ID = "/external_wallets/{walletId}/{assetId}"
    CONTRACTS = "/contracts"
    CONTRACTS_CONTRACT_ID = "/contracts/{contractId}"
    CONTRACTS_CONTRACT_ID_ASSET_ID = "/contracts/{contractId}/{assetId}"
    SUPPORTED_ASSETS = "/supported_assets"
    TRANSACTIONS = "/transactions"
    TRANSACTIONS_ESTIMATE_FEE = "/transactions/estimate_fee"
    TRANSACTIONS_TX_ID = "/transactions/{txId}"
    TRANSACTIONS_EXTERNAL_TX_ID_EXTERNAL_TX_ID_ = "/transactions/external_tx_id/{externalTxId}/"
    TRANSACTIONS_TX_ID_SET_CONFIRMATION_THRESHOLD = "/transactions/{txId}/set_confirmation_threshold"
    TRANSACTIONS_TX_ID_DROP = "/transactions/{txId}/drop"
    TRANSACTIONS_TX_ID_CANCEL = "/transactions/{txId}/cancel"
    TRANSACTIONS_TX_ID_FREEZE = "/transactions/{txId}/freeze"
    TRANSACTIONS_TX_ID_UNFREEZE = "/transactions/{txId}/unfreeze"
    TRANSACTIONS_VALIDATE_ADDRESS_ASSET_ID_ADDRESS = "/transactions/validate_address/{assetId}/{address}"
    TX_HASH_TX_HASH_SET_CONFIRMATION_THRESHOLD = "/txHash/{txHash}/set_confirmation_threshold"
    ESTIMATE_NETWORK_FEE = "/estimate_network_fee"
    PAYMENTS_XBSETTLEMENTS_CONFIGS = "/payments/xb-settlements/configs"
    PAYMENTS_XBSETTLEMENTS_CONFIGS_CONFIG_ID = "/payments/xb-settlements/configs/{configId}"
    PAYMENTS_XBSETTLEMENTS_FLOWS = "/payments/xb-settlements/flows"
    PAYMENTS_XBSETTLEMENTS_FLOWS_FLOW_ID = "/payments/xb-settlements/flows/{flowId}"
    PAYMENTS_XBSETTLEMENTS_FLOWS_FLOW_ID_ACTIONS_EXECUTE = "/payments/xb-settlements/flows/{flowId}/actions/execute"
    PAYMENTS_PAYOUT = "/payments/payout"
    PAYMENTS_PAYOUT_PAYOUT_ID_ACTIONS_EXECUTE = "/payments/payout/{payoutId}/actions/execute"
    PAYMENTS_PAYOUT_PAYOUT_ID = "/payments/payout/{payoutId}"
    GAS_STATION = "/gas_station"
    GAS_STATION_ASSET_ID = "/gas_station/{assetId}"
    GAS_STATION_CONFIGURATION = "/gas_station/configuration"
    GAS_STATION_CONFIGURATION_ASSET_ID = "/gas_station/configuration/{assetId}"
    USERS = "/users"
    AUDITS = "/audits"
    OFF_EXCHANGE_ADD = "/off_exchange/add"
    OFF_EXCHANGE_REMOVE = "/off_exchange/remove"
    OFF_EXCHANGE_SETTLEMENTS_TRADER = "/off_exchange/settlements/trader"
    OFF_EXCHANGE_SETTLEMENTS_TRANSACTIONS = "/off_exchange/settlements/transactions"
    OFF_EXCHANGE_COLLATERAL_ACCOUNTS_MAIN_EXCHANGE_ACCOUNT_ID = "/off_exchange/collateral_accounts/{mainExchangeAccountId}"
    WEBHOOKS_RESEND = "/webhooks/resend"
    WEBHOOKS_RESEND_TX_ID = "/webhooks/resend/{txId}"
    NFTS_OWNERSHIP_TOKENS = "/nfts/ownership/tokens"
    NFTS_OWNERSHIP_COLLECTIONS = "/nfts/ownership/collections"
    NFTS_TOKENS_ID = "/nfts/tokens/{id}"
    NFTS_TOKENS = "/nfts/tokens"
    NFTS_OWNERSHIP_TOKENS_ID_STATUS = "/nfts/ownership/tokens/{id}/status"
    CONNECTIONS = "/connections"
    CONNECTIONS_WC = "/connections/wc"
    CONNECTIONS_WC_ID = "/connections/wc/{id}"
    SCREENING_TRAVEL_RULE_TRANSACTION_VALIDATE = "/screening/travel_rule/transaction/validate"
    SCREENING_TRAVEL_RULE_TRANSACTION_VALIDATE_FULL = "/screening/travel_rule/transaction/validate/full"
    SCREENING_TRAVEL_RULE_VASP_DID = "/screening/travel_rule/vasp/{did}"
    SCREENING_TRAVEL_RULE_VASP = "/screening/travel_rule/vasp"
    SCREEENING_TRAVEL_RULE_VASP_UPDATE = "/screeening/travel_rule/vasp/update"
    TAP_ACTIVE_POLICY = "/tap/active_policy"
    TAP_DRAFT = "/tap/draft"
    TAP_PUBLISH = "/tap/publish"
